// @ts-nocheck

$(function () {

  $('#browse-custom-jrebel-location').click(e => {
    handleBrowseCustomJRebelLocationClick($(e.currentTarget));
  });

  $('#use-bundled-agent').change(e => {
    handleUseBundledAgentRadioChange($(e.currentTarget));
  });

  $('#use-custom-agent').change(e => {
    handleUseCustomAgentRadioChange($(e.currentTarget));
  });

  $('#agent-generation-switch-to-nightly').click(e => {
    handleSwitchToNightlyClick($(e.currentTarget));
  });

  function handleBrowseCustomJRebelLocationClick(button) {
    vscode.postMessage({
      handlerId: 'agentgeneration', type: 'openDirectoryDialog', currentValue: $('#custom-jrebel-location').val()
    });
  }

  function handleUseBundledAgentRadioChange(radio) {
    $('#custom-jrebel-location').prop('disabled', radio.prop("checked"));
    $('#browse-custom-jrebel-location').prop('disabled', radio.prop("checked"));
    vscode.postMessage({
      handlerId: 'agentgeneration', type: 'useBundled'
    });
  }

  function handleUseCustomAgentRadioChange(radio) {
    $('#custom-jrebel-location').prop('disabled', !radio.prop("checked"));
    $('#browse-custom-jrebel-location').prop('disabled', !radio.prop("checked"));
    vscode.postMessage({
      handlerId: 'agentgeneration', type: 'useCustom', customAgentPath: $('#custom-jrebel-location').val()
    });
  }

  function handleSwitchToNightlyClick(button) {
    vscode.postMessage({
      handlerId: 'agentgeneration', type: 'switchToNightly'
    });
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    const message = event.data; // The json data that the extension sent
    switch (message.type) {
      case 'ui.handleAdvancedSettingsData':
        {
          $('#use-bundled-agent').prop('checked', message.data.useBundled);
          $('#use-custom-agent').prop('checked', !message.data.useBundled);
          $('#custom-jrebel-location').prop('disabled', message.data.useBundled);
          $('#browse-custom-jrebel-location').prop('disabled', message.data.useBundled);
          $("#custom-jrebel-location").val(message.data.customAgentPath);
          $("#use-bundled-agent-radio-label").html("JRebel Agent " + message.data.bundledJRebelJarVersion + " (Bundled)");
          $('#agent-generation-switch-to-nightly').prop('disabled', !message.data.downloadNightlyButtonEnabled);
          $('#agent-generation-switch-to-nightly').prop('title', message.data.downloadNightlyButtonTooltip || ""); // tooltip might not be present
          $('#agent-generation-switch-to-nightly').html(message.data.downloadNightlyButtonLabel);
          break;
        }
    }
  });

});
