// @ts-nocheck

$(function () {

  $("#datalogging-enablePerformanceLogCheckbox").click(e => {
    handleEnablePerformanceLogCheckboxClick($(e.currentTarget));
  });

  $("#datalogging-loglevelSelect").change(e => {
    handleLoglevelSelectChange($(e.currentTarget));
  });

  $("#datalogging-button-show-log").click(e => {
    handleShowLogButtonClick($(e.currentTarget));
  });


  function handleEnablePerformanceLogCheckboxClick(cb) {
    vscode.postMessage({ handlerId: 'datalogging', type: 'checkboxClicked', id: cb.prop("id"), checked: cb.prop("checked") });
  }

  function handleLoglevelSelectChange(select) {
    vscode.postMessage({ handlerId: 'datalogging', type: 'selectChanged', id: select.prop("id"), newValue: select.prop("value") });
  }

  function handleShowLogButtonClick(button) {
    vscode.postMessage({ handlerId: 'datalogging', type: 'openLogFile', target: button.prop("title") });
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    const message = event.data; // The json data that the extension sent
    switch (message.type) {
      case 'ui.handleLoggingSettingsData':
        {
          $("#datalogging-enablePerformanceLogCheckbox").prop('checked', message.data.performanceLoggingEnabled);
          $("#datalogging-loglevelSelect").prop("value", message.data.currentLevelValue);
          $("#datalogging-button-show-log").prop("title", message.data.logFilePath);
          break;
        }
    }
  });

  vscode.postMessage({ handlerId: 'datalogging', type: 'dataloggingLoaded' });
});