// @ts-nocheck

$(function () {

  function bindServerRows() {
    $('#servers-table-body .jrebel-onoff').change(e => {
      vscode.postMessage({ handlerId: 'startupguideinstructions', type: 'jrebelToggled', serverId: $(e.target).attr('aria-server-name'), enable: e.target.checked || false });
    });
  }

  function updateServerRow(serverRow, isJRebelEnabled) {
    serverRow.find('.jrebel-onoff').prop('checked', isJRebelEnabled);
  }

  $('#startup-guide-runviaide').change(e => {
    handleRunviaideRadioChange($(e.currentTarget));
  });

  $('#startup-guide-runlocally').change(e => {
    handleRunlocallyRadioChange($(e.currentTarget));
  });

  $('#startup-guide-runremotely').change(e => {
    handleRunremotelyRadioChange($(e.currentTarget));
  });

  function handleRunviaideRadioChange(radio) {
    if (radio.prop("checked")) {
      $('#startup-guide-runviaide-container').removeClass("displaynone");
      $('#startup-guide-runlocally-sub').addClass("displaynone");
      $('#startup-guide-runremotely-sub').addClass("displaynone");
      $('#startup-guide-runlocally-container').addClass("displaynone");
      $('#startup-guide-runremotely-container').addClass("displaynone");
    }
  }

  function handleRunlocallyRadioChange(radio) {
    if (radio.prop("checked")) {
      $('#startup-guide-runviaide-container').addClass("displaynone");
      $('#startup-guide-runlocally-sub').removeClass("displaynone");
      $('#startup-guide-runremotely-sub').addClass("displaynone");
      $('#startup-guide-runremotely-container').addClass("displaynone");
      requestLocalInstructionsUpdate();
    }
  }

  function handleRunremotelyRadioChange(radio) {
    if (radio.prop("checked")) {
      $('#startup-guide-runviaide-container').addClass("displaynone");
      $('#startup-guide-runlocally-sub').addClass("displaynone");
      $('#startup-guide-runremotely-sub').removeClass("displaynone");
      $('#startup-guide-runlocally-container').addClass("displaynone");

      requestRemoteInstructionsUpdate();
    }
  }

  function onJvmBitnessChange(e, jvmTypeChangedMsgId, jqInstructionsContainer, jqServerTypesSelect) {
    const jqJvmBitnessSelect = $(e.currentTarget);
    if (jqJvmBitnessSelect.val() !== '0') {
      const jvmTypeText = jqJvmBitnessSelect.find('option:selected').text();
      const selectedServerText = jqServerTypesSelect.val() !== '0' ? jqServerTypesSelect.find('option:selected').text() : undefined;
      vscode.postMessage({ handlerId: 'startupguideinstructions', type: jvmTypeChangedMsgId, jvmType: jvmTypeText, selectedServer: selectedServerText });
    }
    else {
      jqInstructionsContainer.addClass("displaynone");
      resetServerTypesSelect(jqServerTypesSelect);
    }
  }

  $('#runlocally-jvm-bitness').on('change', (e) => onJvmBitnessChange(e, 'jvmTypeChanged', $('#startup-guide-runlocally-container'), $('#runlocally-target-environment')));

  $('#runremotely-jvm-bitness').on('change', (e) => onJvmBitnessChange(e, 'remoteJvmTypeChanged', $('#startup-guide-runremotely-container'), $('#runremotely-target-environment')));

  function requestLocalInstructionsUpdate() {
    if ($('#runlocally-target-environment').val() !== '0' && $('#runlocally-jvm-bitness').val() !== '0') {
      const jvmTypeText = $('#runlocally-jvm-bitness option:selected').text();
      const serverTypeText = $('#runlocally-target-environment option:selected').text();
      vscode.postMessage({ handlerId: 'startupguideinstructions', type: 'serverTypeChanged', jvmType: jvmTypeText, serverType: serverTypeText });
    }
    else {
      $('#startup-guide-runlocally-container').addClass("displaynone");
    }
  }

  $('#runlocally-target-environment').on('change', requestLocalInstructionsUpdate);

  function requestRemoteInstructionsUpdate() {
    if ($('#runremotely-target-environment').val() !== '0' && $('#runremotely-jvm-bitness').val() !== '0' && $('#runremotely-os').val() !== '0') {
      const osText = $('#runremotely-os option:selected').text();
      const jvmTypeText = $('#runremotely-jvm-bitness option:selected').text();
      const serverTypeText = $('#runremotely-target-environment option:selected').text();
      vscode.postMessage({ handlerId: 'startupguideinstructions', type: 'remoteInstructionsRequested', os: osText, jvmType: jvmTypeText, serverType: serverTypeText });
    }
    else {
      $('#startup-guide-runremotely-container').addClass("displaynone");
    }
  }

  $('#runremotely-target-environment').on('change', requestRemoteInstructionsUpdate);

  $('#runremotely-os').on('change', () => {
    if ($('#runremotely-os').val() !== '0') {
      const osText = $('#runremotely-os option:selected').text();
      const force64Bit = osText.toLowerCase() === 'macos';
      force64BitJvm($('#runremotely-jvm-bitness'), force64Bit);
      if (!force64Bit) {
        requestRemoteInstructionsUpdate();
      }
    }
    else {
      $('#startup-guide-runremotely-container').addClass("displaynone");
    }
  });

  const COPY_SVG = `<svg width="17" height="16" viewBox="0 0 17 16" fill="none" xmlns="http://www.w3.org/2000/svg">
  <path fill-rule="evenodd" clip-rule="evenodd" d="M12.4999 10.6668V2.66683C12.4999 1.93045 11.903 1.3335 11.1666 1.3335H3.16659C2.43021 1.3335 1.83325 1.93045 1.83325 2.66683V10.6668C1.83325 11.4032 2.43021 12.0002 3.16659 12.0002H11.1666C11.903 12.0002 12.4999 11.4032 12.4999 10.6668ZM3.16659 2.66683H11.1666V10.6668H3.16659V2.66683ZM13.8333 12.0002V4.00016C14.5696 4.00016 15.1666 4.59712 15.1666 5.3335V12.0002C15.1666 13.4729 13.9727 14.6668 12.4999 14.6668H5.83325C5.09687 14.6668 4.49992 14.0699 4.49992 13.3335H12.4999C13.2363 13.3335 13.8333 12.7365 13.8333 12.0002Z" fill="currentColor"/>
  </svg>`;

  function createInstructionsItemHtml(item) {
    if (item.type === 'CODE') {
      const encoded = item.text.replaceAll('<', '&lt;').replaceAll('>', '&gt;')
        .replaceAll(/&lt;(\/?)span(.*?)&gt;/g, '<$1span$2>');
      return `<div class="startup-instruction-code"><pre>${encoded}</pre><button class="rebel-push quaternary-button instructions-copy-btn">${COPY_SVG} Copy</button></div>`;
    }
    return `<div class="startup-instruction-item">${item.text}</div>`;
  }

  $('#startup-guide-runlocally-instructions,#startup-guide-runremotely-instructions').on('click', '.instructions-copy-btn', e => {
    const btn = e.currentTarget;
    const textToCopy = $(btn).parent().find('pre').text();
    navigator.clipboard.writeText(textToCopy);
  });

  function updateJvmTypesSelectContent(jqJvmTypesSelect, jvmTypes, force64Bit) {
    resetJvmBitnessSelect(jqJvmTypesSelect);
    let i = 1;
    for (let opt of jvmTypes) {
      jqJvmTypesSelect.append(`<option value="${i++}">${opt}</option>`);
    }
    force64BitJvm(jqJvmTypesSelect, force64Bit);
  }

  function force64BitJvm(jqJvmTypesSelect, force64Bit) {
    if (force64Bit) {
      triggerChangeByOptionText(jqJvmTypesSelect, '64');
    }
    jqJvmTypesSelect.prop('disabled', force64Bit);
  }

  function updateServerTypesSelectContent(jqServerTypesSelect, serverTypes, jqInstructionsContainer, selectedServer) {
    jqInstructionsContainer.addClass("displaynone");
    resetServerTypesSelect(jqServerTypesSelect);
    let i = 1;
    for (let opt of serverTypes) {
      jqServerTypesSelect.append(`<option value="${i++}">${opt}</option>`);
    }
    if (selectedServer) {
      const selectedServerOpt = jqServerTypesSelect.find('option').filter((_, o) => $(o).text() === selectedServer);
      if (selectedServerOpt.length) {
        jqServerTypesSelect.val(selectedServerOpt.val()).trigger('change');
      }
    }
  }

  function updateInstructionsContent(jqInstructionsContainer, jqInstructionsList, instructions) {
    jqInstructionsContainer.removeClass("displaynone");
    jqInstructionsList.empty();
    const rootRecord = instructions;
    for (let record of rootRecord.records) {
      let recDiv = jqInstructionsList.append(createInstructionsItemHtml(record.parsed));
      for (let item of record.items) {
        recDiv.append(createInstructionsItemHtml(item));
      }
    }

  }

  function resetJvmBitnessSelect(jqJvmTypesSelect) {
    jqJvmTypesSelect.empty().append('<option value="0" selected>JVM bitness</option>').prop('disabled', false);
  }

  function resetServerTypesSelect(jqServerTypesSelect) {
    jqServerTypesSelect.empty().append('<option value="0" selected>Target environment</option>');
  }

  function triggerChangeByOptionText(jqSelect, optionText) {
    jqSelect.find('option').filter((_, o) => $(o).text().includes(optionText))
      .prop('selected', true)
      .trigger('change');
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    switch (event.data.type) {
      case 'updateAvailableServers':
        {
          const serversTableBody = $("#servers-table-body");
          serversTableBody.find(".cloned").remove();
          if (event.data.servers.length) {
            $('#no-servers-row').css('display', 'none');
            for (let server of event.data.servers) {
              const serverId = 'server-' + encodeURIComponent(server.serverHandle.id);
              const serverRow = $('#--template-server-row').clone();
              serverRow.prop('id', serverId + '-server-row');
              serverRow.html(serverRow.html()
                .replace(/--template-server/g, serverId)
                .replace(/--TEMPLATE-SERVER-NAME/g, server.serverHandle.id)
                .replace(/--template-sname/g, server.serverHandle.id)
              );
              updateServerRow(serverRow, server.isJRebelEnabled);
              serverRow.css('display', 'table-row');
              serverRow.addClass("cloned");
              serversTableBody.append(serverRow);
            }
            bindServerRows();
          } else {
            $('#no-servers-row').css('display', 'table-row');
          }
          break;
        }
      case 'updateLocalJvmTypes':
        {
          updateJvmTypesSelectContent($('#runlocally-jvm-bitness'), event.data.jvmTypes, event.data.force64Bit);
        }
        break;
      case 'updateLocalServerTypes':
        {
          updateServerTypesSelectContent($('#runlocally-target-environment'), event.data.serverTypes, $('#startup-guide-runlocally-container'), event.data.selectedServer);
        }
        break;
      case 'updateLocalInstructions':
        {
          updateInstructionsContent($('#startup-guide-runlocally-container'), $('#startup-guide-runlocally-instructions'), event.data.instructions);
        }
        break;
      case 'updateRemoteOSsAndJvmTypes':
        {
          $('#runremotely-os').empty();
          $('#runremotely-os').append('<option value="0" selected>Select remote OS</option>');
          let i = 1;
          for (let opt of event.data.oss) {
            $('#runremotely-os').append(`<option value="${i++}">${opt}</option>`);
          }

          updateJvmTypesSelectContent($('#runremotely-jvm-bitness'), event.data.jvmTypes, false);

          triggerChangeByOptionText($('#runremotely-os'), 'Linux');
          triggerChangeByOptionText($('#runremotely-jvm-bitness'), '64');
        }
        break;
      case 'updateRemoteServerTypes':
        {
          updateServerTypesSelectContent($('#runremotely-target-environment'), event.data.serverTypes, $('#startup-guide-runremotely-container'), event.data.selectedServer);
        }
        break;
      case 'updateRemoteInstructions':
        {
          updateInstructionsContent($('#startup-guide-runremotely-container'), $('#startup-guide-runremotely-instructions'), event.data.instructions);
        }
        break;
    }
  });

  vscode.postMessage({ handlerId: 'startupguideinstructions', type: 'startupguideinstructionsShown' });
});