// @ts-nocheck

$(function () {

  $("#workoffline-workOfflineCheckbox").click(e => {
    // arrow functions do not have their own "this" context
    handleWorkOfflineCheckboxClick($(e.currentTarget));
  });

  $("#workoffline-autorenewOfflineSeatCheckbox").click(e => {
    handleAutorenewOfflineSeatCheckboxClick($(e.currentTarget));
  });

  function handleWorkOfflineCheckboxClick(cb) {
    let days = $("#workoffline-offlineSeatDurationSetting").val();
    vscode.postMessage({ handlerId: 'licenses', type: 'checkboxClicked', id: cb.prop("id"), checked: cb.prop("checked"), days: days });
  }

  function handleAutorenewOfflineSeatCheckboxClick(cb) {
    vscode.postMessage({ handlerId: 'licenses', type: 'checkboxClicked', id: cb.prop("id"), checked: cb.prop("checked") });
  }

  $(window).on('message', $e => {
    const event = $e.originalEvent;
    const message = event.data; // The json data that the extension sent
    console.log("workoffline.js got event from extension. " + message.type);
    switch (message.type) {
      case 'ui.updateLicenseData':
        {
          if (message.data.isLicenseServerLicense) {
            $("#workoffline-description").addClass("displaynone");
            $("#workoffline-table").removeClass("displaynone");

            $("#workoffline-workOfflineCheckbox").prop('checked', message.data.isOfflineLease);
            $("#workoffline-offlineSeatDurationSetting").val(message.data.offlineSeatDurationSetting);
            $("#workoffline-autorenewOfflineSeatCheckbox").prop('checked', message.data.autorenewOfflineSeat);

            if (message.data.offlineLeaseExpires) {
              $("#workoffline-offlineLeaseExpiresRow").removeClass("displaynone");
              $("#workoffline-offlineLeaseExpires").html(message.data.offlineLeaseExpires);
            } else {
              $("#workoffline-offlineLeaseExpiresRow").addClass("displaynone");
            }
          } else {
            $("#workoffline-description").removeClass("displaynone");
            $("#workoffline-table").addClass("displaynone");
          }
          break;
        }
      case 'ui.handleActivateLicenseLicensingStatus':
        {
          console.log("workoffline.js got handleActivateLicenseLicensingStatus event. data: " + message.data);
          break;
        }

    }
  });

  console.log("workoffline.js loaded");

});